/* IC(*.inf) T[o[ *//*
2003-05 orca
  HTTP server쐬

2003-07 orca
  infǂݍݏgݍ


c:
  ڑƂ threadĂ邯, thread poolpӂ̂悢

  infƂɎIuWFNgŖʂɋLgȂ悤,
  xgĂȂIuWFNg, ̂悢B
  (obj.infFile.getName() Ƃ OXgɓĂIuWFNgu)
  ̔f, lastaccess ڂɍŐVĂ̂Ń\g

*/
importPackage(java.lang, java.net, java.io)
importClass(java.util.ResourceBundle)
importClass(Packages.BlockedList)


function initInfServer() {
  var rb = ResourceBundle.getBundle('ServerConf')
  var conf = { rb: rb }

  var keys = rb.getKeys()
  while (keys.hasMoreElements()) {
    var key = keys.nextElement()
    conf[key] = rb.getString(key)
  }

  //var arr = conf.mtype.split()
  conf.mtype = {
    htm: 'text/html', html: 'text/html',
    css: 'text/css',
    png: 'image/png',
    js: 'application/x-javascript',
  }

    spawn(function () {
      for (;;) {
        Thread.sleep(1000)
        print('\x1b[s', '\x1b[;H', Thread.activeCount(), ' ')
        System.out.print('\x1b[u')
      }
    })

  return conf
}

function contentType(fname) {
  var n = fname.lastIndexOf('.')
  var ext = fname.substr(n +1)
  return ext in serverConf.mtype? serverConf.mtype[ext]: 'text/plain'
}

function httpHeader(rcode, ctype, clen) {
  var pattern = serverConf.rb.getString('HTTP.header')
  var args = [new Date().toGMTString(), rcode, ctype, clen]
  var head = MessageFormat.format(pattern, args) +'\r\n'
  return head
}


function HttpRequest(request) {
  var arr = request.match(/^([A-Z]*) ([^ ]+) (.*)$/)   // P' 'ŕĂ悢
  this.method = arr[1]
  this.url = arr[2]
  this.ver = arr[3]

  this.head = new StringBuffer()
  this.body = new StringBuffer()
}


function HttpConnect(sk) {
  this._sk = sk
  this.sbin = sk.inputStream
  this.sbout = sk.outputStream
  this.sr = new BufferedReader(new InputStreamReader(sk.inputStream))
  this.sw = new OutputStreamWriter(sk.outputStream)
  this.rqlist = new BlockedList()   // []
}
HttpConnect.prototype = {

  prepRootPage: function () {
    var html = new InfHTML(serverConf, 'list')
    var pattern = serverConf['HTML.list.item']
    for (var i in infList) {
      var item = MessageFormat.format(pattern, [i, infList[i]])
      html.write(item.getBytes())   // 邢 String(item)
    }

    var baos = new ByteArrayOutputStream()
    html.writeTo(new DataOutputStream(baos))

    this.sw.write(httpHeader('200 OK', 'text/html', baos.size()))
    this.sw.flush()
    baos.writeTo(this.sbout)
  },

  prepPage: function (page) {
    if (!page) page = 'index.html'   // resourceŎw肵
    var f = new File(serverConf.docroot, page)
    if (!f.exists() || f.name.indexOf('..') > 0)
      return this.notFound()

    var bin = new DataInputStream(new FileInputStream(f))
    var ba = java.lang.reflect.Array.newInstance(Byte.TYPE, f.length())
    try {
      bin.readFully(ba)
    }
    catch (e) {}
    finally {
      if (bin != null)
        try bin.close()
        catch (e) {}

      bin = null
    }

    var rc = httpHeader('200 OK', contentType(f.name), ba.length)
    this.sw.write(rc)
    this.sw.flush()
    this.sbout.write(ba, 0, ba.length)
  },

  prepInfPage: function (inf, page) {
    var fname = infList[inf]
    if (typeof fname == 'string')
      infList[inf] = new InfUnfold(fname, inf)

    var baos = new ByteArrayOutputStream()
    var out = new DataOutputStream(baos)

    var obj = infList[inf]
    var n = parseInt(page.substr(1), 10)

    if (page[0] == 'p' && !isNaN(n))
      obj.writeHTMLTo(out, Math.min(n, obj.contents.length -1))
    else
      obj.writeIndexTo(out)
    out.flush()

    var rc = httpHeader('200 OK', 'text/html; charset=Shift_JIS', baos.size())
    this.sw.write(rc)
    this.sw.flush()
    baos.writeTo(this.sbout)
  },

  notFound: function () {
    var buff = serverConf.rb.getString('HTTP.resp404')
    var html = buff.getBytes()

    var rc = httpHeader('404 NotFound', 'text/html; charset=Shift_JIS', html.length)
    this.sw.write(rc)
    this.sw.flush()
    this.sbout.write(html, 0, html.length)
  },

  sendLoop: function () {
    try for (;;) {
      var obj = this.rqlist.remove(0)   // this.rqlist.shift()
      if (obj == undefined) {   // this.rqlist.isEmpty()
        System.out.print('*')
        break;   // continue;
      }

      /* ǂ̂[ contentvꂽׂ */
      var arr = obj.url.split('/')

      if (arr[1] == '') {   // root page
        infList = infInit()
        this.prepRootPage()
      }
      else if (arr[1] == serverConf.docname) {
        arr.shift()
        arr.shift()
        this.prepPage(arr.join('/'))
      }
      else {
        if (infList == undefined)
          infList = infInit()

        if (infList[arr[1]] != undefined)
          this.prepInfPage(arr[1], arr[2])
        else
          this.notFound()
      }
    }
    //catch (e) {}   //  debuĝƂ͊O(comment out) 
    finally {
      print('do-w-close')

      if (this.sw != null)
        try this.sw.close()
        catch (e) {}
      this.sw = null
    }
  },

  recvLoop: function () {
    var sk = this.sr

    try for (;;) {
      var rline = sk.readLine()
      if (rline) {
        var obj = new HttpRequest(rline)
        this.rqlist.add(obj)   // this.rqlist.push(obj)
      }
      else
        break;

      while ((rline = sk.readLine()) != '') {
        obj.head.append(rline +'\r\n')

      }

      var arr = obj.head.toString().match(/Content-Length:[^\d]*(\d+)/i)
      if (arr) {
        var ln = arr[1]
        print('#len', arr[1])
        var ba = java.lang.reflect.Array.newInstance(Byte.TYPE, ln)
        this.sbin.read(ba, 0, ln)   // I܂(܂)ǂݍ
        obj.body = ba
      }
    }
    catch (e) {
      print('#read', e)
    }
    finally {
      this.rqlist.add(null)

      print('do-close')
      if (this.sr != null)
        try this.sr.close()
        catch (e) {}
      this.sr = null
    }
  },

}


/**
 * Main
 */
load('InfView.js', 'InfHTML.js')

var serverConf = initInfServer()
var server = new ServerSocket(serverConf.waitport)
print('wait port', server.localPort)

var infList   // = undefined
try for (;;) {
  var sk = server.accept()
  sk.setTcpNoDelay(true)
  print('connect from', sk.inetAddress, '(',sk.port,')')

  var t = new HttpConnect(sk)
  spawn(function () { t.recvLoop() })
  spawn(function () { t.sendLoop() })
}
catch (e) {
  print('#main', e)
}
finally {
  if (sk != null)
    sk.close()

  if (server != null) {
    server.close()
    server = null
  }
}

/* -- End of Script -- */
